#!/usr/bin/env python

'''

    @version $Id: AlarmDialog.py,v 1.2 2005/01/14 00:52:36 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *

class AlarmDialog(wxDialog):
    uniqueID = 0
    def __init__(self, *args, **kwds):
        # begin wxGlade: AlarmDialog.__init__
        kwds["style"] = wxDIALOG_MODAL|wxCAPTION
        wxDialog.__init__(self, *args, **kwds)
        self.alarmName = wxStaticText(self, -1, "Name of Alarm")
        self.AlarmNameText = wxTextCtrl(self, -1, "New Alarm")
        self.monday = wxCheckBox(self, -1, "Monday")
        self.tuesday = wxCheckBox(self, -1, "Tuesday")
        self.wednesday = wxCheckBox(self, -1, "Wednesday")
        self.thursday = wxCheckBox(self, -1, "Thursday")
        self.friday = wxCheckBox(self, -1, "Friday")
        self.saturday = wxCheckBox(self, -1, "Saturday")
        self.sunday = wxCheckBox(self, -1, "Sunday")
        self.timeLabel = wxStaticText(self, -1, "Time")
        self.hours = wxSpinCtrl(self, -1, "8", min=1, max=12)
        self.hLabel = wxStaticText(self, -1, "H")
        self.minutes = wxSpinCtrl(self, -1, "30", min=0, max=59)
        self.mLabel = wxStaticText(self, -1, "M")
        self.ampm = wxChoice(self, -1, choices=["AM", "PM"])
        self.done = wxButton(self, wxID_OK, "Done")
        self.close = wxButton(self, wxID_CANCEL, "Close")

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: AlarmDialog.__set_properties
        self.SetTitle("Create Your Alarm")
        self.SetSize((300, 277))
        self.alarmName.SetFont(wxFont(14, wxDEFAULT, wxNORMAL, wxBOLD, 0, ""))
        self.monday.SetValue(1)
        self.tuesday.SetValue(1)
        self.wednesday.SetValue(1)
        self.thursday.SetValue(1)
        self.friday.SetValue(1)
        self.timeLabel.SetFont(wxFont(13, wxDEFAULT, wxNORMAL, wxBOLD, 0, ""))
        self.ampm.SetSelection(0)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: AlarmDialog.__do_layout
        mainSizer = wxBoxSizer(wxVERTICAL)
        timeSizer = wxBoxSizer(wxHORIZONTAL)
        nameSizer = wxBoxSizer(wxHORIZONTAL)
        buttonSizer = wxBoxSizer(wxHORIZONTAL)
        nameSizer.Add(self.alarmName, 1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        nameSizer.Add(self.AlarmNameText, 1, wxALIGN_CENTER_VERTICAL|wxALIGN_CENTER_HORIZONTAL, 0)
        mainSizer.Add(nameSizer, 1, wxEXPAND, 0)
        mainSizer.Add(self.monday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        mainSizer.Add(self.tuesday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        mainSizer.Add(self.wednesday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        mainSizer.Add(self.thursday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        mainSizer.Add(self.friday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        mainSizer.Add(self.saturday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        mainSizer.Add(self.sunday, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        timeSizer.Add(self.timeLabel, 2, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 0)
        timeSizer.Add(self.hours, 2, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        timeSizer.Add(self.hLabel, 1, wxALIGN_CENTER_VERTICAL, 0)
        timeSizer.Add(self.minutes, 2, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        timeSizer.Add(self.mLabel, 1, wxALIGN_CENTER_VERTICAL, 0)
        timeSizer.Add(self.ampm, 2, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxGROW, 0)
        mainSizer.Add(timeSizer, 1, wxEXPAND, 0)
        buttonSizer.Add(self.done,1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0)
        buttonSizer.Add(self.close,1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL,0)
        mainSizer.Add(buttonSizer,1,wxEXPAND,0)
        self.SetAutoLayout(1)
        self.SetSizer(mainSizer)
        self.Layout()
        # end wxGlade

    def setWindowTitle(self, newtitle):
        self.SetTitle(newtitle)

# end of class AlarmDialog


