#!/usr/bin/env python

'''

    @version $Id: mixerpanel.py,v 1.6 2005/01/14 00:52:37 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *
from pyAlarm import paGlobals

ID_SLIDER = 1000

class MixerPanel(wxPanel):
    bars = dict()
    def __init__(self, *args, **kwds):
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxPanel.__init__(self, *args, **kwds)
        self.sizer = wxBoxSizer(wxVERTICAL)
        self.mixer = paGlobals.gCommand.GetMixer()
        
        
        sliderID = ID_SLIDER
        try:
            self.mixer.Initialize()
            for devid, device, devtype in self.mixer.GetDevices():
                slider = wxSlider( self, sliderID, self.mixer.GetLevel(devid), 0, 100, style = wxSL_HORIZONTAL | wxSL_AUTOTICKS | wxSL_LABELS)
                tmpText = wxStaticText(self, -1, label=device, style=wxALIGN_RIGHT)
                tmpSizer = wxBoxSizer(wxHORIZONTAL)
                tmpSizer.Add(tmpText,1,wxALL | wxALIGN_CENTRE)
                tmpSizer.Add(slider,5,wxALL | wxEXPAND)
                self.sizer.Add(tmpSizer,1,wxALL|wxEXPAND)
                EVT_COMMAND_SCROLL(self, sliderID, self.OnScrollMe)
                self.bars[str(sliderID)] = devid
                sliderID += sliderID
                tmpText = None
                tmpSizer = None
        except AttributeError:
            tmpText = wxStaticText(self,-1,label='No Mixer Available', style=wxALIGN_LEFT)
            self.sizer.Add(tmpText,1,wxALL | wxEXPAND)
        except IOError:
            tmpText = wxStaticText(self,-1,label='No Mixer Available', style=wxALIGN_LEFT)
            self.sizer.Add(tmpText,1,wxALL | wxEXPAND)
        
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()
        self.Centre()
        
        
    def OnScrollMe(self, evt):
        scroller = evt.GetId()
        self.mixer.SetLevel(str(self.bars[str(scroller)]),evt.GetPosition())
        
        
        
        
        
