#!/usr/bin/env python

'''

    @version $Id: paabout.py,v 1.7 2005/01/14 00:52:37 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *
from wxPython.html import *
from pyAlarm import paGlobals
from string import replace
import os



CLOSE_ID = 1000

class paAboutWin(wxDialog):
    def __init__(self, *args, **kwds):
        #kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxDialog.__init__(self, *args, **kwds)
        self.AboutNotebook = wxNotebook(self, -1)
        self.sizer = wxBoxSizer(wxVERTICAL)
        self.AboutSizer = wxNotebookSizer(self.AboutNotebook)
        self.mainAbout = AboutMain(self.AboutNotebook, -1)
        self.pluginAbout = AboutPlugins(self.AboutNotebook, -1)
        
        self.closeButton = wxButton(self, CLOSE_ID, label='Close')
        self.AboutNotebook.AddPage(self.mainAbout, "pyAlarm")
        self.AboutNotebook.AddPage(self.pluginAbout, "Plugins")
        self.sizer.Add(self.AboutSizer, 1, wxALL|wxEXPAND, 0)
        self.sizer.Add(self.closeButton, 0, wxALIGN_CENTER, 0)
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()
        self.Centre()
        
        EVT_BUTTON(self, CLOSE_ID, self.OnClose)
        
    def OnClose(self, evt):
        self.Close()
    
class AboutPlugins(wxPanel):
    def __init__(self, *args, **kwds):
        wxPanel.__init__(self, *args, **kwds)
        self.htmlWin = wxHtmlWindow(self, -1)
        
        pluginText = '<html><body><font size=-2>'
        
        pluginNames = paGlobals.gCommand.GetPluginNames()
        for plug in pluginNames:
            pluginCredits = paGlobals.gCommand.GetPluginCredits(plug)
            pluginText += '<h5>' + plug + '</h5>'
            pluginText += '<p>Version ' + pluginCredits['version'] + '</p>'
            pluginText += '<p>' + pluginCredits['author'] + '</p>'
            pluginText += '<p>' + pluginCredits['copyright'] + '</p>'
            pluginText += '<p>' + pluginCredits['license'] + '</p>'
            pluginText += '<p>' + pluginCredits['url'] + '</p>'
        
        pluginText += '</font></body></html>'
        
        self.htmlWin.SetPage(pluginText)
        self.sizer = wxBoxSizer(wxVERTICAL)
    
        self.sizer.Add(self.htmlWin, 1, wxGROW)
        
        self.SetSizer(self.sizer)
        self.SetAutoLayout(True)
        
    
class AboutMain(wxPanel):
    def __init__(self, *args, **kwds):
        wxPanel.__init__(self, *args, **kwds)

        aboutFile = os.path.join(paGlobals.gCommand.GetBasePath(), 'data', 'paabout.html')
        
        self.htmlWin = wxHtmlWindow(self, -1)
        self.htmlWin.LoadPage(aboutFile)
        self.sizer = wxBoxSizer(wxVERTICAL)
    
        self.sizer.Add(self.htmlWin, 1, wxGROW)
        
        self.SetSizer(self.sizer)
        self.SetAutoLayout(True)
            
    
    
    
    
    
    