#!/usr/bin/env python

'''
File Information:
    
   Last changed by: $Author: davidfancella $
                On: $Date: 2005/01/18 07:03:48 $
                
   This file is part of $Name:  $
   
   $Revision: 1.10 $
   
'''


'''

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *
from pyAlarm import paGlobals
from pyAlarm import graphics
from pyAlarm import paGlobals
import sys

ID_OK = 1000
ID_APPLY = 1001
ID_CANCEL = 1002

ID_PLUGINCHOICES = 2000

class paPreferences(wxFrame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxFrame.__init__(self, *args, **kwds)
        
        try:
             self.SetIcon(graphics.getApplIcon())
        finally:
            pass
        self.SetSize((430, 343))
        self.MainNotebook = wxNotebook(self, -1, style=wxNB_RIGHT)
        self.mainPanel = paprefMain(self.MainNotebook, -1)
        self.GuiPanel = paprefGUI(self.MainNotebook, -1)
        self.pluginPanel = paprefPlugin(self.MainNotebook, -1)
        self.SetTitle("Preferences")
        self.MainNotebook.AddPage(self.mainPanel, "Main")
        self.MainNotebook.AddPage(self.GuiPanel, "Interface")
        self.MainNotebook.AddPage(self.pluginPanel, "Plugins")
        self.noteSizer = wxNotebookSizer(self.MainNotebook)
        self.sizer = wxBoxSizer(wxVERTICAL)
        self.sizer.Add(self.noteSizer, 1, wxALL|wxEXPAND, 0)
        
        self.buttonSizer = wxBoxSizer(wxHORIZONTAL)
        
        self.ApplyButton = wxButton(self, ID_APPLY, label="Apply")
        self.CancelButton = wxButton(self, ID_CANCEL, label="Cancel")
        self.OkButton = wxButton(self, ID_OK, label="Ok")
        
        self.buttonSizer.Add(self.ApplyButton,1,wxALL|wxEXPAND,0)
        self.buttonSizer.Add(self.CancelButton,1,wxALL|wxEXPAND,0)
        self.buttonSizer.Add(self.OkButton,1,wxALL|wxEXPAND,0)
        
        self.sizer.Add(self.buttonSizer, 0, wxALL|wxEXPAND, 0)
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()
        self.Centre()
        
        EVT_BUTTON(self, ID_OK, self.OnOk)
        EVT_BUTTON(self, ID_APPLY, self.OnApply)
        EVT_BUTTON(self, ID_CANCEL, self.OnCancel)
        
    def OnOk(self, evt):
        self.Apply()
        paGlobals.gCommand.SavePreferences()
        self.Close(true)
        
    def OnApply(self, evt):
        self.Apply()
    
    def OnCancel(self, evt):
        self.Close(true)
        
    def Apply(self):
        print "Applying changes"
        self.mainPanel.Apply()
        self.GuiPanel.Apply()
        self.pluginPanel.Apply()

class paprefMain(wxPanel):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxPanel.__init__(self, *args, **kwds)
        
        self.sizer = wxFlexGridSizer(0,2,2,2)
        self.snoozesizer = wxBoxSizer(wxHORIZONTAL)
        
        # Setup mixer row
        mixerchoice = ["default"]
        for mixer in paGlobals.gCommand.GetAllMixers():
            mixerchoice.append(mixer.Name())
        
        self.MixerSelect = wxChoice(self, -1, choices=mixerchoice)

        self.sizer.Add(wxStaticText(self, -1, label="Use this mixer", style=wxALIGN_RIGHT),1,wxALIGN_RIGHT,0)
        self.sizer.Add(self.MixerSelect,2,wxALIGN_LEFT,0)
        
        # Setup media row
        mediachoice = ["default"]
        for mixer in paGlobals.gCommand.GetAllMedia():
            mediachoice.append(mixer.Name())
        
        self.MediaSelect = wxChoice(self, -1, choices=mediachoice)
                        
        self.sizer.Add(wxStaticText(self, -1, label="Preferred media player", style=wxALIGN_RIGHT),1,wxALIGN_RIGHT,0)
        self.sizer.Add(self.MediaSelect,2,wxALIGN_LEFT,0)
        
        # Setup playlist row
        filerchoice = ["default"]
        for mixer in paGlobals.gCommand.GetAllMediaFile():
            filerchoice.append(mixer.Name())
        
        self.FilerSelect = wxChoice(self, -1, choices=filerchoice)
        
        self.sizer.Add(wxStaticText(self, -1, label="Global media file manager", style=wxALIGN_RIGHT),1,wxALIGN_RIGHT,0)
        self.sizer.Add(self.FilerSelect,2,wxALIGN_LEFT,0)
                
        self.snoozeTimer = wxSpinCtrl(self, -1, str(paGlobals.gCommand.snoozeminutes), min=1, max=60)
        self.snoozeText = wxStaticText(self, -1, "Snooze Time")

        self.sizer.Add(self.snoozeText,1,wxALIGN_RIGHT,0)
        self.sizer.Add(self.snoozeTimer,2,wxALIGN_LEFT,0)
        
        self.logFileText = wxTextCtrl(self, -1, paGlobals.gCommand.logFile)
        self.logButton = wxButton(self, -1, label="Browse...")
        self.stupidSizer = wxBoxSizer(wxHORIZONTAL)
        self.stupidSizer.Add(self.logFileText,0,wxALIGN_LEFT | wxEXPAND,0)
        self.stupidSizer.Add(self.logButton,1,wxALIGN_LEFT | wxEXPAND,0)
        
        self.sizer.Add(wxStaticText(self, -1, label="Sleep Log", style=wxALIGN_RIGHT),1,wxALIGN_RIGHT,0)
        self.sizer.Add(self.stupidSizer)

        self.logCheckbox = wxCheckBox(self, -1, label="")
        self.sizer.Add(wxStaticText(self, -1, label="Keep Sleep Log?", style=wxALIGN_RIGHT),1,wxALIGN_RIGHT,0)
        self.sizer.Add(self.logCheckbox)
        
        self.LoadCurrent()
        
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()

    def LoadCurrent(self):
        self.MixerSelect.SetStringSelection(paGlobals.gCommand.prefMixer)
        self.MediaSelect.SetStringSelection(paGlobals.gCommand.prefMedia)
        self.FilerSelect.SetStringSelection(paGlobals.gCommand.prefFiler)
        self.snoozeTimer.SetValue(paGlobals.gCommand.snoozeminutes)
        self.logFileText.SetValue(paGlobals.gCommand.logFile)
        self.logCheckbox.SetValue(paGlobals.gCommand.logMe)
                
    def Apply(self):
        paGlobals.gCommand.prefMixer = self.MixerSelect.GetStringSelection()
        paGlobals.gCommand.prefMedia = self.MediaSelect.GetStringSelection()
        paGlobals.gCommand.prefFiler = self.FilerSelect.GetStringSelection()
        paGlobals.gCommand.snoozeminutes = int(self.snoozeTimer.GetValue())
        paGlobals.gCommand.logFile = self.logFileText.GetValue()
        paGlobals.gCommand.logMe = self.logCheckbox.GetValue()
        paGlobals.gCommand.SetLogger()
    
class paprefGUI(wxPanel):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxPanel.__init__(self, *args, **kwds)
        
        self.sizer = wxBoxSizer(wxVERTICAL)
        
        self.saveWindow = wxCheckBox(self, -1, label="Save Window Geometry")
        self.centerWindow = wxCheckBox(self, -1, label="Center window on load")

        self.saveWindow.SetValue(paGlobals.gCommand.restoreInterface)
        self.centerWindow.SetValue(paGlobals.gCommand.centerMe)
        
        self.sizer.Add(self.saveWindow,1,wxALIGN_LEFT,0)
        self.sizer.Add(self.centerWindow,1,wxALIGN_LEFT,0)
        
        self.saveWindow.SetValue(paGlobals.gCommand.restoreInterface)
        self.centerWindow.SetValue(paGlobals.gCommand.centerMe)
        
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()
        
    def Apply(self):
        paGlobals.gCommand.restoreInterface = self.saveWindow.GetValue()
        paGlobals.gCommand.centerMe = self.centerWindow.GetValue()
        

class paprefPlugin(wxPanel):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxPanel.__init__(self, *args, **kwds)
        
        self.MainNotebook = wxNotebook(self, -1, style=wxNB_BOTTOM)
        
        self.sizer = wxNotebookSizer(self.MainNotebook)
        
        self.plugins = paGlobals.gCommand.GetAllPlugins()
        
        self.allPanels = dict()
               
        for plugin in self.plugins:
            self.allPanels[plugin.Name()] = paprefPluginTree(self.MainNotebook, -1, plugin=plugin)
            self.MainNotebook.AddPage(self.allPanels[plugin.Name()], plugin.Name())
        
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()

    def Apply(self):
        for plugin in self.plugins:
            self.allPanels[plugin.Name()].Apply()
            
class paprefPluginTree(wxPanel):
    def __init__(self, *args, **kwds):
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        self.mypluginIs = kwds.pop('plugin')
        wxPanel.__init__(self, *args, **kwds)
        
        self.sizer = wxBoxSizer(wxVERTICAL)
        try:
            self.options = self.mypluginIs.GetOptionNames()
            self.optiondict = dict()
            
            
            if len(self.options) > 0:
                for option in self.options:
                    optiontype, defaultvalue, value, comment, choices = self.mypluginIs.GetOption(option)
                    pluginConfigpath = "/Plugins/" + self.mypluginIs.Name() + option
                    if optiontype == 'yesno':
                        self.optiondict[option] = wxCheckBox(self, -1, label=comment)
                        tmpOption = eval(paGlobals.gCommand.GetConfig(pluginConfigpath, defaultvalue))
                        self.optiondict[option].SetValue(tmpOption)
                    elif optiontype == 'string':
                        tmpOption = paGlobals.gCommand.GetConfig(pluginConfigpath, defaultvalue)
                        self.optiondict[option] = wxTextCtrl(self, -1, value=tmpOption)
                    elif optiontype == 'choice':
                        pass
                    self.sizer.Add(self.optiondict[option],0,wxALIGN_LEFT,0)
            else:
                self.sizer.Add(wxStaticText(self, -1, label="This plugin has no configurable options.", style=wxALIGN_RIGHT),0,wxALIGN_LEFT,0)

        except:
            pass
        
        try:
            pluginInfo = wxTextCtrl(self, -1, style=wxTE_READONLY | wxTE_MULTILINE)
            pluginInfo.AppendText("Dependencies Loaded:\n")
            for f in self.mypluginIs.GetModules().keys():
                pluginInfo.AppendText("        " + f + "\n")
            pluginInfo.AppendText('' + "\n")
            if len(self.mypluginIs.GetFailedDeps()) > 0:
                pluginInfo.AppendText('Dependencies not loaded:' + "\n")
                for f in self.mypluginIs.GetFailedDeps():
                    pluginInfo.AppendText('        ' + f + "\n")
            pluginInfo.AppendText('---------------------------------------------------' + "\n")
            if sys.platform in self.mypluginIs.GetPlatforms():
                pluginInfo.AppendText('This plugin runs on this platform.' + "\n")
            else:
                pluginInfo.AppendText('This plugin does not run on this platform.' + "\n")
            pluginInfo.AppendText('\n')
            pluginInfo.AppendText('Platforms supported:\n')
            for f in self.mypluginIs.GetPlatforms():
                pluginInfo.AppendText('         ' + f + "\n")
            self.sizer.Add(pluginInfo,1,wxEXPAND,0)
        except:
            pass
            
        
        self.SetAutoLayout(1)
        self.SetSizer(self.sizer)
        self.Layout()
        
    def Apply(self):
        for option in self.options:
            optiontype, defaultvalue, value, comment, choices = self.mypluginIs.GetOption(option)
            pluginConfigpath = "/Plugins/" + self.mypluginIs.Name() + option
            if optiontype == 'yesno':
                value = str(self.optiondict[option].IsChecked())
            elif optiontype == 'string':
                value = self.optiondict[option].GetValue()
            elif optiontype == 'choice':
                pass
            paGlobals.gCommand.SetConfig(pluginConfigpath, value)
        
                   

