#!/usr/bin/env python

'''

    @version $Id: PlayListData.py,v 1.6 2005/01/14 00:52:36 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from string import *
from mutex import *
import os.path

class playListItem:
    myIndex = 0
    newFile = True
    def __init__(self, pathToSong):
        pathToSong = strip(pathToSong)
        (self.path, self.song) = os.path.split(pathToSong)
        self.fullpath = pathToSong
        return

    def __cmp__(self,other):
        return cmp(self.myIndex,other)

    def SetIndex(self, newIndex):
        self.myIndex = newIndex

    def GetSong(self):
        return self.song

    def GetPath(self):
        return self.path

    def GetFullPath(self):
        return self.fullpath
        
    def GetIndex(self):
        return self.myIndex

    def GetSongPath(self):
        return os.path.join(self.path,self.song)

class playListData(mutex):
    songs = []
    currentHighIndex = 0
    #newFile = False

    def __init__(self):
        # initialize the list
        return

    def AddNew(self, song):
        self.tmpItem = playListItem(song)
        self.tmpItem.SetIndex(self.GetNewIndex())
        self.songs.append(self.tmpItem)
        #newFile = self.hasNewFile()
        return self.tmpItem.GetIndex()

    def hasNewFile(self):
        for afile in self.songs:
            if afile.newFile == True:
                return True
                
    def isNewFile(self, index):
        return self.songs[index].newFile
        
    def SetNewFile(self, index, value):
        self.songs[index].newFile = value
        
    def Modify(self, index, song):
        self.songs.pop(index)
        self.songs.insert(index,alarm)

    def Delete(self, songIndex):
        self.index = self.songs.index(int(songIndex))
        self.songs.pop(self.index)

    def ReadItem(self,i):
        return self.songs[i]

    def GetSongFile(self,songIndex):
        self.index = self.songs.index(songIndex)
        return self.songs[self.index].GetSong()

    def GetSongPath(self,songIndex):
        #self.index = self.songs.index(songIndex)
        return self.songs[songIndex].GetPath()

    def GetSongFullPath(self,songIndex):
        return self.songs[songIndex].GetFullPath()
        
    def GetSongIndex(self, index):
        return self.songs[index].GetIndex()

    def Count(self):
        return len(self.songs)

    def Clear(self):
        self.songs = []

    def GetNewIndex(self):
        self.currentHighIndex = self.currentHighIndex + 1
        return self.currentHighIndex

    def OpenPlayListData(self, filename):
        try:
            self.playlistfile = open(filename, 'r')
        except:
            return 0

        for line in self.playlistfile:
            self.AddNew(line)

        self.playlistfile.close()
        return 1

    def SavePlayListData(self, filename):
        self.playlistfile = open(filename, 'w')
        for a in range(self.Count()):
            self.playlistfile.write(self.songs[a].GetSongPath()+'\n')
        self.playlistfile.close()

    def GetAllAsList(self):
        self.newList = []
        for a in range(self.Count()):
            self.newList.append(self.songs[a].GetSongPath())
        return self.newList
