#!/usr/bin/env python

'''
File Information:
    
   Last changed by: $Author: davidfancella $
                On: $Date: 2005/01/18 07:03:48 $
                
   This file is part of $Name:  $
   
   $Revision: 1.13 $
   
'''


'''

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *
from threading import *
import paGlobals
import os, time,string

class paAction(Thread):
    def __init__(self, players):
        Thread.__init__(self)
        #self._notify_window = notify_window
        self._want_abort = False
        self.players = players
        self.songqueue = paGlobals.gCommand.playlistdata.GetAllAsList()
        self.prefMedia = paGlobals.gCommand.prefMedia
        self.prefFiler = paGlobals.gCommand.prefFiler
        
        self.filer = paGlobals.gCommand.GetFiler()
        for filer in paGlobals.gCommand.GetAllFilers():
            if filer.Name() == self.prefFiler:
                self.filer = filer
                break
                
        # This starts the thread running on creation, but you could
        # also make the GUI thread responsible for calling this
        if self.players is not None:
            self.isPlaying = True
            for player in self.players:
                if player.Name() == self.prefMedia:
                    self.prefPlayer = player
            self.start()
        else:
            self.isPlaying = False
            print "No players available!"

	# method: run
    # The run method is derived from Thread, and must be overridden.  Here, we override Run and
	# play a song.

    def run(self):
        self.filer.RenderList()
        self.nextSong = True
        while(1):
            if self.nextSong:
                self.currentSong = string.strip(os.path.join(self.filer.GetNextFile()))
            else:
                self.currentSong = string.strip(os.path.join(self.filer.GetPreviousFile()))
                self.nextSong = True
            root, ext = os.path.split(self.currentSong)
            root, ext = os.path.splitext(ext)
            ext = string.strip(string.lower(ext))
            if ext in self.prefPlayer.GetSupports():
                self.thisplayer = self.prefPlayer
            else:
                for player in self.players:
                    if ext in player.GetSupports():
                        self.thisplayer = player
            if self.thisplayer is not None:
                print
                print '----------------------------------------------'
                print 'Using ' + str(self.thisplayer)
                print '----------------------------------------------'
                print
                self.thisplayer.Initialize()
                self.thisplayer.SetFile(self.currentSong)
                print self.currentSong
                self.thisplayer.start()
                while self.thisplayer.IsPlaying:
                    if self._want_abort:
                        self.thisplayer.Stop()
                if self._want_abort:
                    return
            self.thisplayer = None
        #wxPostEvent(self._notify_window,ResultEvent(0))

	# method: abort
	# Abort is called from the GUI thread in order to stop music playing.

    def abort(self):
        # Method for use by main thread to signal an abort
        self._want_abort = True

    def pause(self):
        self.thisplayer.Pause()
        
    def next(self):
        self.nextSong = True
        self.thisplayer.Stop()
        
    def previous(self):
        self.nextSong = False
        self.thisplayer.Stop()

    def IsPaused(self):
        return self.thisplayer.IsPaused()
    
