#!/usr/bin/env python

'''

    @version $Id: alarmcontent.py,v 1.3 2005/01/14 00:52:37 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from xml.sax.handler import ContentHandler
from alarmlistitem import *

class paAlarmContent(ContentHandler):
    alarms = []
    mymode = 'top'
    tmpAlarm = None
    
    def startElement(self,name, attrs):
        # Have to check this before checking the mode
        if self.mymode == 'alarm':
            if name == 'day':
                if attrs.has_key('enabled'):
                    enabled = attrs.getValue('enabled')
                    if enabled == 'True':
                        self.tmpAlarm.SetDay(attrs.getValue('type'), True)
                    else:
                        self.tmpAlarm.SetDay(attrs.getValue('type'), False)
                else:
                    self.tmpAlarm.SetDay(attrs.getValue('type'), False)
                
        # Now check to see if it's an alarm, or something else
        if name == "alarm":
            self.mymode = 'alarm'
            self.tmpAlarm = alarmListItem(name=attrs.getValue('name'), time=attrs.getValue('time'))
        
    def endElement(self,name):
        if name == 'alarm':
            self.alarms.append(self.tmpAlarm)
            self.tmpAlarm = None
            self.mymode = 'top'
        
    def characters(self,content):
        pass
        
    def GetAlarms(self):
        return self.alarms


