#!/usr/bin/env python

'''

    @version $Id: alarmlistitem.py,v 1.3 2005/01/18 03:39:07 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *
import random

class alarmListItem:
    days = dict()
            
    index = 0
            
    def __init__(self, name=None, time=None, days=None):
        self.name = name
        self.ID = str(random.randint(0,10000))
        if isinstance(time,wxDateTime):
            self.time = time
        elif time is not None:
            tmpTime = wxDateTime()
            tmpTime.ParseTime(time)
            self.time = tmpTime
        else:
            self.time = time
        if days is not None:
            self.days[self.ID] = days
        else:
            self.days[self.ID] = { 'monday' : False,
                                    'tuesday' : False,
                                    'wednesday' : False,
                                    'thursday' : False,
                                    'friday' : False,
                                    'saturday' : False,
                                    'sunday' : False }
        #drop = self.TimeToNext(wxDateTime_Now())

    ## method: __cmp__
    # Compares it's index with an index passed in    
    def __cmp__(self,other):
        return cmp(self.index,other)
            
    def __str__(self):
        return self.name
        
    def GetDays(self):
        return self.days[self.ID]
        
    def GetDay(self, day):
        return self.days[self.ID][day]

    def SetDays(self, days):
        self.days[self.ID] = days
        
    def SetDay(self, day, value):
        self.days[self.ID][day] = value
        
    def GetName(self):
        return self.name

    def SetName(self, name):
        self.name = name
        
    def GetTime(self):
        return self.time
        
    def SetTime(self, time):
        self.time = time
        
    def GetNext(self):
        return self.next
        
    # time represents the current time passed in, usually now, must be a wxDateTime
    def TimeToNext(self, time):
        # first copy the alarm's time
        tmpTime = self.time
        
        # now copy (time)'s year and month
        tmpTime.SetYear(time.GetYear())
        tmpTime.SetMonth(time.GetMonth())
        
        # just setting up for some arithmetic that will be very legible :)
        OneDay = wxTimeSpan(24,0,0,0)
        
        # the monster if statement says "If alarm is today"
        if self.days[self.ID][wxDateTime_GetWeekDayName(tmpTime.GetWeekDay()).lower()]:
            tmpTime.SetDay(time.GetDay())
                
            # check to see if the next alarm is today or not
            tmpResult = tmpTime.Subtract(time)
            if tmpResult.IsPositive():
                self.next = tmpTime
                return tmpResult
        
        # now do it anyway because we need tmpTime initialized to today no matter what
        tmpTime.SetDay(time.GetDay())

        loops = 0
        while loops < 7:
            tmpTime = tmpTime + OneDay
            alarmDay = wxDateTime_GetWeekDayName(tmpTime.GetWeekDay()).lower()
            if self.days[self.ID][alarmDay]:
                self.next = tmpTime
                return tmpTime.Subtract(time)
            loops += 1
            
        return None
            
        
        