#!/usr/bin/env python

'''

    @version $Id: alarmwriter.py,v 1.3 2005/01/14 00:52:37 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

import string

class paAlarmWriter:
    filewriter = None
    alarms = None
    
    def Write(self, filename, alarms):
        self.alarms = alarms
        self.filewriter = open(filename,"w")
        self.WriteHeader()
        self.WriteAlarms()
        self.WriteFooter()
        self.filewriter.close()
        
    def WriteAlarms(self):
        self.filewriter.write('<allalarms>\n')
        
        for alarm in self.alarms:
            self.filewriter.write('<alarm name="' + alarm.GetName() + '" time="' + alarm.GetTime().FormatTime() + '">\n')
            for day, value in alarm.GetDays().iteritems():
                if value:
                    enabled = "True"
                else:
                    enabled = "False"
                dayrecord = '    <day type="' + day + '" enabled="' + enabled + '" />\n'
                self.filewriter.write(dayrecord)
            self.filewriter.write('</alarm>\n\n')
        self.filewriter.write('</allalarms>\n\n')
        
    def WriteHeader(self):
        header = '<?xml version="1.0"?>\n\n<pax xmlns="none">\n'
        self.filewriter.write(header)
        
    def WriteFooter(self):
        self.filewriter.write('</pax>\n')
        
    
    
    