#!/usr/bin/env python

'''

    @version $Id: events.py,v 1.8 2005/01/18 05:06:22 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *

paMASTERDATA = 0
paCOUNTDOWN = 1
paDIRSCAN = 2
paTAGSCAN = 3
paNEWSONG = 4

''' this stuff is for the threading '''
paEVT_RESULT_ID = wxNewEventType()

def paEVT_RESULT(win, func):
    win.Connect(-1, -1, paEVT_RESULT_ID, func)

# Data classes
#       These classes are used to store data in the custom event type.  They will all derive from a master class
#       that contains a constant that defines what type of data is in it

class paMasterData:
    dataType = paMASTERDATA

class paNewSong(paMasterData):
    dataType = paNEWSONG
    def __init__(self, data):
        self.song = data
         
class paTimerCountDown(paMasterData):
    dataType = paCOUNTDOWN
    alarm = ''   # String representing the alarm that's referenced
    timenow = ''  # String containing the time *right now*
    
    def __init__(self, timeleft, alarm):
        self.timeleft = timeleft
        self.timenow = wxDateTime_Now().Format("%I:%M:%S%p")
        self.alarm = alarm
    
    
class paDirScan(paMasterData):
    def __init__(self, data):
        self.dataType = paDIRSCAN    
        self.Path = data
            
class paTagScan(paMasterData):
    dataType = paTAGSCAN
    def __init__(self, data, index):
        self.Index = index
        self.Title = data['Song']
        self.Artist = data['Artist']
        self.Album = data['Album']
    
#class: ResultEvent

#    A custom event class used to pass messages back to the GUI thread.  The messages used
#	are integers, and more or less arbitrary.  Just make sure that the event you post is
#	understood in the class that receives it.

class ResultEvent(wxPyCommandEvent):
    """Simple event to carry arbitrary result data"""
    eventType = paEVT_RESULT_ID
    def __init__(self, data):
        wxPyCommandEvent.__init__(self,self.eventType,-1)
        self.data = data
        self.extradata = ''
    def Clone( self ):
        self.__class__( self.GetId() )

# Revision history
#  $Log: events.py,v $
#  Revision 1.8  2005/01/18 05:06:22  davidfancella
#  Adding logging, a little at a time
# 

                