#!/usr/bin/env python

'''

    @version $Id: pathreads.py,v 1.9 2005/01/18 05:06:22 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from wxPython.wx import *
from threading import *
import os
import paGlobals
from pyAlarm.events import *

class paClock(wxTimer):
    def SetAlarms(self, alarms, notify_window):
        self.alarms = alarms
        self._notify_window = notify_window

    def Notify(self):
        # Check the time, check the next alarm, sound alarm if it is time
        now = wxDateTime_Now()
        nextAlarm = self.alarms.GetNextAlarm(now)
        if nextAlarm:
            timeRemaining = nextAlarm.GetNext() - now
            if timeRemaining < wxTimeSpan_Seconds(2):
                paGlobals.gCommand.SoundAlarm(nextAlarm)
            else:
                tmpdata = paTimerCountDown(timeRemaining.Format("%H:%M:%S"), str(nextAlarm))
                tmpEvent = ResultEvent(tmpdata)
                self._notify_window.AddPendingEvent(tmpEvent)
        else:
            tmpdata = paTimerCountDown(now.Format("%I:%M:%S%p"), "No Alarms Left!")
            tmpEvent = ResultEvent(tmpdata)
            self._notify_window.AddPendingEvent(tmpEvent)

''' This entire class is removed, but I'm keeping it around as reference for the ID3 module
class paPlayListAdder(Thread):

    def __init__(self, notify_window, mode, data):
        Thread.__init__(self)
        self.mode = mode
        self._notify_window = notify_window
        self._want_abort = 0
        self.data = data
    
    def run(self):
        if self.mode == 'newscan':
            for (dirpath, dirsome, files) in os.walk(self.data):
                for a in files:
                    event = ResultEvent(paDirScan(os.path.join(dirpath,a)))
                    self._notify_window.AddPendingEvent(event)
        elif self.mode == 'gettags':
            counttotal = self.data.Count()
            for index in range(counttotal):
                if self.data.isNewFile(index):
                    path = self.data.GetSongFullPath(index)
                    (head, tail) = os.path.splitext(os.path.basename(path))
                    if tail in paGlobals.gCommand.MediaSupported():
                        idTags = ID3.ID3(path)
                        eventData = paTagScan(idTags,index)
                        event = ResultEvent(eventData)
                        self._notify_window.AddPendingEvent(event)
                    self.data.SetNewFile(index, False)
                    
	# method: abort
	# Abort is called from the GUI thread in order to stop the scan.

    def abort(self):
        # Method for use by main thread to signal an abort
        self._want_abort = 1

class paPlayListTagreader(Thread):
    pass
        '''
        
        