#!/usr/bin/env python

'''

    @version $Id: mixer.py,v 1.3 2005/01/14 00:52:37 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

import plugin

# paMixer is the class you should derive from to make a mixer plugin

class paMixerPlugin(plugin.paPlugin):
    pluginType = plugin.paMIXER
    thisString = 'Generic Mixer Plugin'
    
    def __init__(self):
        plugin.paPlugin.__init__(self)
    
    def Setup(self):
        # basic configuration here, gets called when the plugin is loaded
        pass

    def Initialize(self):
        # This gets called before the mixer is read from/written to.  A good place to open the mixer device
        # although not necessarily the best place
        pass    
    
    def GetDevices(self):
        # should return a list of tuples of the form (device ID, device string, device type [input or output])
        raise plugin.pluginBroke, "No devices found because the dolt didn't implement this method"
        
    def GetLevel(self, device):
        # device will be passed in as an ID matching the ID portion of the tuples returned from GetDevices
        raise plugin.pluginBroke, "GetLevel not implemented"
        
    def SetLevel(self, device, level):
        # Level will be passed in as a percentage, 0-100, device will again match GetDevices ID
        raise plugin.pluginBroke, "SetLevel not implemented"
        
        

    