#!/usr/bin/env python

'''

    @version $Id: playplugin.py,v 1.6 2005/01/14 00:52:37 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

import plugin
from thread import *

# playplugin is the class you must derive from the write a plugin that plays

class paMedia(plugin.paPlugin):
    __mediaTypes = dict()
    pluginType = plugin.paMEDIA
    wantsFile = True
    pluginAction = plugin.paALARM
    
    def __init__(self):
        plugin.paPlugin.__init__(self)
    
    # Should have a Play method
    def Play(self):
        raise plugin.pluginBroke, "This Plugin can't Play"

    # Should have a Stop method
    def Stop(self):
        raise plugin.pluginBroke, "This Plugin can't Stop"
    
    # Should have a Pause method, and it should toggle play
    def Pause(self):
        raise plugin.pluginBroke, "This Plugin can't Pause"

    # Call AddSupport in your plugin constructor to register support for a media type
    def AddSupport(self, mType):
        self.__mediaTypes[str(self.ID)].append(mType)

    def GetID(self):
        num = plugin.paPlugin.GetID(self)
        self.__mediaTypes[str(num)] = []
        return num
        
    # Called by plugin manager to determine what this plugin supports        
    def GetSupports(self):
        return self.__mediaTypes[str(self.ID)]
        
    def start(self):
        self.IsPlaying = True
        start_new_thread(self.run,())
    
    def run(self):
        #try:
        self.IsPlaying = True
        self.Play()
        print "Done playing"
        #except:
        #    print "Can't play for some reason, disabling plugin"
        #    self.Break()
        self.IsPlaying = False
        


