#!/usr/bin/env python

'''
File Information:
    
   Last changed by: $Author: davidfancella $
                On: $Date: 2005/01/18 06:11:41 $
                
   This file is part of $Name:  $
   
   $Revision: 1.11 $
   
'''

'''

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from pyAlarm.plugin.playplugin import *

class paAudierePlayer(paMedia):
    def __init__(self):
        paMedia.__init__(self)
    
    def SetFile(self, file):
        self.currentSong = file
        
    def Setup(self):
        self.AddPlatform("linux2")
        self.AddPlatform("win32")
        self.AddSupport('.mp3')
        self.AddSupport('.ogg')
        self.AddSupport('.flac')
        self.MyNameIs('Audiere Player for pyAlarm')
        self.LoadModule('audiere')
        self.LoadModule('time')
        self.SetAuthor('Dave Fancella')
        self.SetCopyright('2004')
        self.SetLicense('GNU General Public License v2.0 or higher')
        self.SetAuthUrl('http://www.davefancella.com/')
        self.SetVersion('0.1')
        
        #self.LoadModule('thispluginisintentionallybroken')
        
    def Initialize(self):
        self._want_abort = False;
        self._is_paused = False;
        self.modules = self.GetModules()
    
    def Play(self):
        device = self.modules['audiere'].open_device()
        self.audfile = device.open_sound(self.currentSong, 0)
        self.audfile.playing = True
        self.Callback('SetFile')(self, self.currentSong)
        while self._want_abort is not True:
            if self.audfile.playing == False:
                if (self._is_paused is False):
                    self.audfile = None
                    device = None
                    return
            pass
        self.audfile = None
        device = None
                    
    def Stop(self):
        self._want_abort = True
    
    def Pause(self):
        self._is_paused = not self._is_paused
        self.audfile.playing = not self.audfile.playing
        
    def IsPaused(self):
        return self._is_paused


