#!/usr/bin/env python

'''

    @version $Id: paMad.py,v 1.8 2005/01/18 06:11:41 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from pyAlarm.plugin.playplugin import *

class paMad(paMedia):
    def __init__(self):
        paMedia.__init__(self)

    def SetFile(self, file):
        self.currentSong = file
        
    def Setup(self):
        self.AddPlatform("linux2")
        self.AddSupport('.mp3')
        self.MyNameIs('MAD Player for pyAlarm')
        self.LoadModule('mad')
        self.LoadModule('ao')
        
        self.SetAuthor('Dave Fancella')
        self.SetCopyright('Copyright 2004')
        self.SetLicense('GNU General Public License v2.0 or higher')
        self.SetAuthUrl('http://www.davefancella.com/')
        self.SetVersion('0.1')
        
        
        # uncomment the following line to disable this plugin
        #self.LoadModule('thispluginisintentionallybroken')

        
    def Initialize(self):
        self._want_abort = False;
        self._is_paused = False;
        self.modules = self.GetModules()
                
    def Play(self):
        print "Playing"
        self.madfile = self.modules['mad'].MadFile(self.currentSong)
        dsp = self.modules['ao'].AudioDevice('oss', rate=self.madfile.samplerate())
        while 1:
            if self._want_abort:
                dsp = None
                return
            if not self._is_paused:
                self.buf = self.madfile.read()
                if self.buf is None: break
                dsp.play(self.buf, len(self.buf))
        dsp = None
                    
    def Stop(self):
        self._want_abort = True
    
    def Pause(self):
        self._is_paused = not self._is_paused
        
    def IsPaused(self):
        return self._is_paused


