#!/usr/bin/env python

'''

    @version $Id: paMixer.py,v 1.7 2005/01/14 00:52:36 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from pyAlarm.plugin.mixer import *

class paMixer(paMixerPlugin):
    thisString = "Standard pyAlarm Mixer for Linux"
    Constants = dict()
    devices = []
    
    def __init__(self):
        paMixerPlugin.__init__(self)
    
    def Setup(self):
        self.LoadModule("ossaudiodev")
        self.AddPlatform("linux2")
        self.MyNameIs('OSS Mixer for Linux')
            
        self.Constants['SOUND_MIXER_VOLUME'] = "Volume"
        self.Constants['SOUND_MIXER_PCM'] = "PCM"
        self.Constants['SOUND_MIXER_ALTPCM'] = "Alt PCM"
        self.Constants['SOUND_MIXER_CD'] = "CD"
        self.Constants['SOUND_MIXER_SPEAKER'] = "Speaker"
        self.Constants['SOUND_MIXER_LINE'] = "Line"
        self.Constants['SOUND_MIXER_MIC'] = "Mic"
        self.Constants['SOUND_MIXER_NRDEVICES'] = "Noise Reduction"
        self.Constants['SOUND_MIXER_BASS'] = "Bass"
        self.Constants['SOUND_MIXER_TREBLE'] = "Treble"
        self.Constants['SOUND_MIXER_SYNTH'] = "Synth"
        self.Constants['SOUND_MIXER_IMIX'] = "Imix"
        self.Constants['SOUND_MIXER_RECLEV'] = "Rec"
        self.Constants['SOUND_MIXER_IGAIN'] = "IGain"
        self.Constants['SOUND_MIXER_OGAIN'] = "OGain"
        self.Constants['SOUND_MIXER_LINE1'] = "Line 1"
        self.Constants['SOUND_MIXER_LINE2'] = "Line 2"
        self.Constants['SOUND_MIXER_LINE3'] = "Line 3"
        self.Constants['SOUND_MIXER_DIGITAL1'] = "Digital 1"
        self.Constants['SOUND_MIXER_DIGITAL2'] = "Digital 2"
        self.Constants['SOUND_MIXER_DIGITAL3'] = "Digital 3"
        self.Constants['SOUND_MIXER_PHONEIN'] = "Phone In"
        self.Constants['SOUND_MIXER_PHONEOUT'] = "Phone Out"
        self.Constants['SOUND_MIXER_VIDEO'] = "Video"
        self.Constants['SOUND_MIXER_RADIO'] = "Radio"
        self.Constants['SOUND_MIXER_MONITOR'] = "Monitor"
        self.SetAuthor('Dave Fancella')
        self.SetCopyright('2004')
        self.SetLicense('GNU General Public License v2.0 or higher')
        self.SetAuthUrl('http://www.davefancella.com/')
        self.SetVersion('0.1')
        
    def Initialize(self):
        self.modules = self.GetModules()
        
    def GetDevices(self):
        tmpMix = self.modules['ossaudiodev'].openmixer()
        controls = tmpMix.controls()
        for k,v in self.Constants.items():
            evaller = 'controls & (1 << self.modules[\'ossaudiodev\'].' + k + ')'
            if eval(evaller):
                self.devices.append( (k, v, 'w') )
        tmpMix.close()
        return self.devices
        
    def GetLevel(self, device):
        tmpMix = self.modules['ossaudiodev'].openmixer()
        tmpdevice = eval('self.modules[\'ossaudiodev\'].' + device)
        levelL, levelR = tmpMix.get(tmpdevice)
        tmpMix.close()
        level = int((levelL + levelR) / 2)
        return level
        
    def SetLevel(self, device, level):
        tmpMix = self.modules['ossaudiodev'].openmixer()
        tmpdevice = eval('self.modules[\'ossaudiodev\'].' + device)
        tmpMix.set(tmpdevice,(level,level))
        tmpMix.close()
            
            

