#!/usr/bin/env python

'''

    @version $Id: paPyGamePlayer.py,v 1.8 2005/01/18 06:11:41 davidfancella Exp $

    This file is part of pyAlarm.

    pyAlarm is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    pyAlarm is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with pyAlarm; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	pyAlarm is copyright 2003 by David Fancella

'''

from pyAlarm.plugin.playplugin import *

class paPyGamePlayer(paMedia):
    def __init__(self):
        paMedia.__init__(self)
    
    def SetFile(self, file):
        self.currentSong = file
        
    def Setup(self):
        self.AddPlatform("linux2")
        self.AddPlatform("win32")
        self.AddSupport('.mp3')
        self.AddSupport('.ogg')
        self.MyNameIs('pyGame Player for pyAlarm')
        self.LoadModule('pygame')
        self.SetAuthor('Dave Fancella')
        self.SetCopyright('2004')
        self.SetLicense('GNU General Public License v2.0 or higher')
        self.SetAuthUrl('http://www.davefancella.com/')
        self.SetVersion('0.1')
        
        # uncomment the following line to disable this plugin
        #self.LoadModule('thismoduleintentionallybroke')
        
    def Initialize(self):
        self.modules = self.GetModules()
        self.modules['pygame'].init()
        self._want_abort = False
        self._is_paused = False
        self._unpause = False
                
    def Play(self):
        print "Playing with pyGame!"
        self.modules['pygame'].mixer.music.load(self.currentSong)
        print "Loaded song"
        self.modules['pygame'].mixer.music.play()
        print "Playing song"
        self.modules['pygame'].mixer.music.set_volume(1.0)
        while self.modules['pygame'].mixer.music.get_busy():
            if self._want_abort:
                self.modules['pygame'].mixer.music.stop()
                return
            if self._is_paused:
                self.modules['pygame'].mixer.music.pause()
            if self._unpause:
                self._unpause = False
                self._is_paused = False
                self.modules['pygame'].mixer.music.unpause()
            pass
                    
    def Stop(self):
        self._want_abort = True
    
    def Pause(self):
        if self._is_paused is False:
            self._is_paused = True
        else:
            self._unpause = True
        
    def IsPaused(self):
        return self._is_paused


